"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Poll = function () {
  function Poll(action, options) {
    _classCallCheck(this, Poll);

    this.action = action;
    this.options = options;
    this.interval = this.options.interval || 5000;
    this.delayOnStart = this.options.delayOnStart || false;
    this.isPolling = false;

    // bind class methods
    this.poll = this.poll.bind(this);
    this.start = this.start.bind(this);
    this.stop = this.stop.bind(this);
    this.setInterval = this.setInterval.bind(this);
    this.resetInterval = this.resetInterval.bind(this);
  }

  _createClass(Poll, [{
    key: "poll",
    value: function poll() {
      var interval = this.interval;

      if (this.isPolling) {
        // invoke the action
        this.action();
        setTimeout(this.poll, interval);
      }
    }
  }, {
    key: "start",
    value: function start() {
      if (this.isPolling) {
        return;
      }

      this.isPolling = true;

      // wait for the specified interval before triggering the first
      // request if we're delaying on start
      if (this.delayOnStart) {
        setTimeout(this.poll, this.interval);
      } else {
        this.poll();
      }
    }
  }, {
    key: "stop",
    value: function stop() {
      this.isPolling = false;
    }
  }, {
    key: "setInterval",
    value: function setInterval(interval) {
      this.interval = interval;
    }
  }, {
    key: "resetInterval",
    value: function resetInterval() {
      this.interval = this.options.interval;
    }
  }]);

  return Poll;
}();

exports.default = Poll;
module.exports = exports["default"];